# -*- coding: utf-8 -*-
"""Installer for the brasil.gov.newfieldcomplement package."""

from setuptools import find_packages
from setuptools import setup


with open("README.rst", "r") as fh:
    long_description = fh.read()

setup(
    name='brasil.gov.newfieldcomplement',
    version='1.1.0',
    description="An add-on for Plone",
    long_description=long_description,
    # Get more from https://pypi.python.org/pypi?%3Aaction=list_classifiers
    classifiers=[
        "Environment :: Web Environment",
        "Framework :: Plone",
        "Framework :: Plone :: 4.3",
        "Programming Language :: Python",
        "Programming Language :: Python :: 2.7",
        "Operating System :: OS Independent",
        "License :: OSI Approved :: GNU General Public License v2 (GPLv2)",
    ],
    keywords='Python Plone',
    author='PloneGovBr',
    author_email='gov@plone.org.br',
    url='',
    license='GPL version 2',
    packages=find_packages('src', exclude=['ez_setup']),
    namespace_packages=['brasil', 'brasil.gov'],
    package_dir={'': 'src'},
    include_package_data=True,
    zip_safe=False,
    install_requires=[
        'eea.facetednavigation',
        'five.pt',
        'plone.api',
        'plone.app.contenttypes',
        'plone.app.registry',
        'plone.app.upgrade',
        'plone.directives.form',
        'Products.CMFPlone >=4.3',
        'Products.GenericSetup',
        'setuptools',
        'zope.i18nmessageid',
        'zope.interface',
        'z3c.jbot',
        'collective.monkeypatcher',
        'collective.dexteritytextindexer',
    ],
    extras_require={
        'test': [
            'plone.app.robotframework',
            'plone.app.testing [robot] >=4.2.2',
            'plone.browserlayer',
            'plone.testing',
            'robotsuite',
        ],
},
    entry_points="""
    [z3c.autoinclude.plugin]
    target = plone
    """,
)
